registerMoverInstruction( "MoveDirection", "list Up 0 Down 1 North 2 East 3 South 4 West 5\tint 1 1024 1\tfloat 0.01 100 0.01 1" );

function event_special_movers_moveDirection( %obj, %dir, %dist, %speed )
{
	if ( %dist < 1 || %dist >= 1024 || mFloor( %dist ) !$= %dist )
	{
		return;
	}
	
	if ( %speed < 0.01 || %speed > 100 )
	{
		return;
	}
	
	switch ( %dir )
	{
		case 0: %dir = "0 0 1";
		case 1: %dir = "0 0 -1";
		case 2: %dir = "1 0 0";
		case 3: %dir = "0 1 0";
		case 4: %dir = "-1 0 0";
		case 5: %dir = "0 -1 0";
		default: return;
	}
	
	%obj.addMoverInstruction( "moveDirection", %dir, %dist, %speed );
}

function add_mover_instruction_moveDirection( %brick, %index, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5 )
{
	%brick.moverInstructionDir[ %index ] = %arg0;
	%brick.moverInstructionDist[ %index ] = %arg1;
	%brick.moverInstructionSpeed[ %index ] = %arg2;
}

function remove_mover_instruction_moveDirection( %brick, %index, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5 )
{
	%brick.moverInstructionDir[ %index ] = "";
	%brick.moverInstructionDist[ %index ] = "";
	%brick.moverInstructionSpeed[ %index ] = "";
}

function start_mover_instruction_moveDirection( %brick, %index )
{
	%pos = vectorAdd( %brick.shapeBrick.getPosition(), vectorScale( %brick.moverInstructionDir[ %index ], %brick.moverInstructionDist[ %index ] / 2 ) );
	%brick.shapeBrick.setMoveSpeed( %brick.moverInstructionSpeed[ %index ] / 2 );
	%brick.shapeBrick.moveToPosition( %pos );
}